function [ statesdot, outputs, j_statesdot, j_outputs ] = mb_fm_mex_sourceRobot( states, controls )
%mb_fm_mex_sourceRobot
% File automatically generated by FALCON.m

%=== Extract Data From Input ==============================================
x = states(1);
vX = states(2);
y = states(3);
vY = states(4);
aX = controls(1);
aY = controls(2);

%=== Jacobians and Hessians ===============================================
j_x = zeros(1,6);
j_x(:,1) = eye(1);
j_vX = zeros(1,6);
j_vX(:,2) = eye(1);
j_y = zeros(1,6);
j_y(:,3) = eye(1);
j_vY = zeros(1,6);
j_vY(:,4) = eye(1);
j_aX = zeros(1,6);
j_aX(:,5) = eye(1);
j_aY = zeros(1,6);
j_aY(:,6) = eye(1);

% Combine Variables to states
states = [x; vX; y; vY];
j_states = [j_x(1,:); j_vX(1,:); j_y(1,:); j_vY(1,:)];

% Combine Variables to controls
controls = [aX; aY];
j_controls = [j_aX(1,:); j_aY(1,:)];

%=== Write Constants ======================================================

%=== Call sys_de333256aa3f64854082fd9b6efede0c ============================
[statedottmp, xOut, vxOut, yOut, vyOut, j_statedottmp, j_xOut, j_vxOut, j_yOut, j_vyOut] = sys_de333256aa3f64854082fd9b6efede0c(states, controls);

% Hessian Jacobian for sys_de333256aa3f64854082fd9b6efede0c
tmp_j_input_sys_de333256aa3f64854082fd9b6efede0c = [j_states; j_controls];

% Calculation of Jacobian with respect to function global input for sys_de333256aa3f64854082fd9b6efede0c
j_statedottmp = j_statedottmp * tmp_j_input_sys_de333256aa3f64854082fd9b6efede0c;
j_xOut = j_xOut * tmp_j_input_sys_de333256aa3f64854082fd9b6efede0c;
j_vxOut = j_vxOut * tmp_j_input_sys_de333256aa3f64854082fd9b6efede0c;
j_yOut = j_yOut * tmp_j_input_sys_de333256aa3f64854082fd9b6efede0c;
j_vyOut = j_vyOut * tmp_j_input_sys_de333256aa3f64854082fd9b6efede0c;

% Combine Variables to statesdot
statesdot = [statedottmp];
j_statesdot = [j_statedottmp(1,:); j_statedottmp(2,:); j_statedottmp(3,:); j_statedottmp(4,:)];

% Combine Variables to outputs
outputs = [xOut; vxOut; yOut; vyOut];
j_outputs = [j_xOut(1,:); j_vxOut(1,:); j_yOut(1,:); j_vyOut(1,:)];

end
